n = int(input())

grupid = dict()
for i in range(n):
    s = input()
    # Pythonis multihulga tüüpi ei ole,
    # teeme selle asemel s tähtede sorteeritud loendi
    t = ''.join(sorted(s))
    # lisame s tema tähtede multihulgale vastavasse gruppi
    if t not in grupid:
        grupid[t] = [s]
    else:
        grupid[t].append(s)

print(len(grupid))
for grupp in grupid.values():
    print(len(grupp))
    for s in grupp:
        print(s)
